package cn.yyxx.eyuangame.core.utils

import android.content.Context
import cn.yyxx.eyuangame.base.utils.Logger
import com.tencent.mmkv.MMKV
import com.tencent.mmkv.MMKVHandler
import com.tencent.mmkv.MMKVLogLevel
import com.tencent.mmkv.MMKVRecoverStrategic
import java.io.File


/**
 * @author #Suyghur.
 * Created on 2021/06/25
 */
class MMKVUtils private constructor() : MMKVHandler {

    var mmkv: MMKV? = null

    fun init(context: Context) {
        val dir = context.getExternalFilesDir("")!!.absolutePath + File.separator + "/user_info"
        MMKV.initialize(context, dir, MMKVLogLevel.LevelInfo)
        MMKV.registerHandler(this)
        mmkv = MMKV.defaultMMKV()
    }

    override fun onMMKVCRCCheckFail(mmapID: String?): MMKVRecoverStrategic {
        return MMKVRecoverStrategic.OnErrorDiscard
    }

    override fun onMMKVFileLengthError(mmapID: String?): MMKVRecoverStrategic {
        return MMKVRecoverStrategic.OnErrorDiscard
    }


    override fun wantLogRedirecting(): Boolean {
        return true
    }

    override fun mmkvLog(level: MMKVLogLevel?, file: String?, line: Int, function: String?, message: String?) {
        val log = "<${file.toString()}:${line}::${function}>${message}"
        Logger.d(log)
    }

    companion object {
        fun getInstance(): MMKVUtils {
            return MMKVUtilsHolder.INSTANCE
        }
    }

    private object MMKVUtilsHolder {
        val INSTANCE: MMKVUtils = MMKVUtils()
    }
}